#! /usr/bin/env python
## -*- coding: utf-8 -*-
## (C) 2012: Hans Georg Schaathun <georg@schaathun.net> 

"""
Crossvalidation

:Module:    svm.ml.xvalidate
:Date:      $Date$
:Revision:  $Revision$
:Copyright: © 2012: Hans Georg Schaathun <georg@schaathun.net>
"""

import pyml
import numpy as np

def xvalidate(cls,k,x,y,seed=0,**kw):
   """Cross-validate a model

   :Parameters:
      cls : class of the classifier to validate
      k : integer
        to perform k-fold crossvalidation
      x : 2-D array
        training set feature vectors
      y : 1-D array
        training set labels
   All other keyword arguments are passed to the classifier constructor.
   """
   x = np.asarray(x,dtype=np.float)
   (N,D) = x.shape
   idx = mlpy.cv_kfold(N,k,seed=seed)
   R = 0.0
   for tr,ts in idx:
       C = cls(**kw)
       C.learn( x[tr,:], y[tr] )
       P = C.pred( x[ts,:] )
       check = ( P == y[ts] )
       R += np.sum(check)
   return R / N
